//Cdigo fuente de las pginas 214-215

class punto : public figura {
  	private:
    		double x, y;

  	public:
		punto(double i= 0.0, double j= 0.0) { 
			x= i; y= j;
		}

		~punto() {
		}

    		double Distancia(const punto & p) const { 
			return sqrt(sqr(p.x - x) + sqr(p.y - y));
		}

    		double Area() const { 
			return 0.0; 
		}
	};

	class cuadrilatero : public figura {
  	protected:
    		punto	v[4];	// Un cuadrilatero se puede definir con 
 						// cuatro puntos. Hay muchas otras formas
  	public:
    		cuadrilatero(double x1, double y1, double x2, double y2, 
		             double x3, double y3, double x4, double y4) {
			v[0] = punto(x1,y1);
			v[1] = punto(x2,y2);
			v[2] = punto(x3,y3);
			v[3] = punto(x4,y4);
		}

		~cuadrilatero() {
		}

    		bool Regular() const { 
			double Dist;
			Dist= v[3].Distancia(v[0]);
			for(int i= 0; i < 2; i++)
				if (Dist != v[i].Distancia(v[i+1]) )
				      return false;
			return 1;
		}

		double Perimetro() const { 
			double Per;
			Per= v[3].Distancia(v[0]);
			for(int i= 0; i <= 2; i++)
				Per+= v[i].Distancia(v[i+1])
			return Per;
		}
    	
		int Lados() const { 
			return 4; 
		}
	};

	class	cuadrado: public cuadrilatero {
  	private:
		// nada, todo lo que necesita lo hereda
  	public:
		cuadrado(double x1, double y1, double x2, double y2)	
			// Con dos puntos basta
			: cuadrilatero(x1, y1, x2, y2, ..?..)
			// Los dems se calcularan usando una frmula 			
			// trigonomtrica. Por abreviar no se detalla

    		bool	Regular() const { 
			return true; 
		}	// Un cuadrado es regular

    		double Perimetro() const { 
			return 4 * v[0].Distancia(v[1]); 	// 4 * l
		}

		double Area() const { 				
			double d= v[0].Distancia(v[1]);
			return d * d;                     // l2
		}
	};
