	//Cdigo de las pginas 274-275	

	// Indica el tamao del fichero. Puede lanzar excepciones
	// del tipo CExcepcionFichero (y su derivadas)
	int TamFichero(char *s) throw (CExcepcionFichero) {
		int tam;
		// Proceso para calcular tamao
		if (fichero_no_existe)
			throw CExcepcionFicheroNoExiste(fichero);

		if (error_acceso)
			throw CExcepcionFicheroNoAcceso(fichero);

		if (error_fichero)
			throw CExcepcionFichero("Fichero corrupto", fichero);

		return tam;
	}

	// Reserva memoria. Slo puede lanzar CExcepcionMemoria
	char* ReservaMemoria(int Tam) throw (CExcepcionMemoria) {
		if (error_memoria) 
			throw CExcepcionMemoria();
		return 0;
	}

	void main() {
	  try {
			int tam = TamFichero("fichero.txt");
			char * ReservaMemoria(tam);
	  }
	  catch (CExcepcionMemoria e) {
			cout << "Error de memoria" << e.Descripcion() << endl;
	  }
	  catch (CExcepcionFicheroNoExiste e) {
			cout << "El fichero " << e.Fichero() 
			     << " no existe" << endl;
	  }
	  catch (CExcepcionFichero e) {
	  // Aqu se tratan CExcepcionFicheroNoAcceso y CExcepcionFichero
			cout << "Error en fichero" << e.Descripcion() << endl;
	  }
	  catch (CExcepcion e) {
			cout << "CExcepcin no determinada" 
			     << e.Descripcion() << endl;
	  }
	  catch (...) {
			cout << "Error indeterminado";
	  }
	}	
