//Cdigo fuente de las pginas 358-359

#include <iostream>
#include <valarray>
using namespace std;

template <class T> void muestra(const valarray <T> &l) {
    int s,i;
    s=l.size();              // Nmero de elementos de l
    for (i = 0; i<s; ++i)    // Recorre y muestra el valarray
        cout << l[i] << " ";
    cout << endl;
}

void main() {
    int v1[]={1,2,3,4,5};
    int v2[]={6,7,8,9,10},t;
    // crea va1 y va2 con los elementos de v1 y v2, respect.
    valarray<int> va1(v1,5);
    valarray<int> va2(v2,5), va3(5);

    cout << "Valores de va1 " << endl;
    muestra(va1);
    cout << "Valores de va2 " << endl;
    muestra(va2);

    // Gira a la izquierda dos posiciones
    va3= va1.shift(2);
    cout << "Valores de va1 despus de shift(2) \n";
    muestra(va3);

    // Gira a la izquierda dos posiciones circularmente
    va3= va1.cshift(2);
    cout << "Valores de va1 despus de cshift(2) \n";
    muestra(va3);

    // suma 5 a todos los elementos de va2
    va3= va2+5;
    cout << "Valores de va2 despus de sumar 5"
            " a todos sus elementos \n";
    muestra(va3);

    // suma todos los elementos de va2
    t=va2.sum();
    cout << "La suma de los elementos de va2 es : "<<t<<endl;
    // obtiene el mximo y el mnimo de va2
    cout << "El mximo de va2 es: " << va2.max() << 
            " y el mnimo es: " << va2.min() << endl; 
    va1.resize(7,8);
    cout << "va1 despus de resize(7,8)\n";
    muestra(va1);
}
