	//Cdigo de las pginas 394-395

	#include <iostream>
	#include <string>
	#include <map>
	using namespace std;

	typedef map<int, string> MAP;

	template <class T> void muestra(const map<T, string> &l) {
	  MAP::iterator i;

      // Recorre y muestra el conjunto 
      for (i = l.begin(); i != l.end(); ++i)
        cout << i->first << " " << i->second<<endl;
      cout << endl;
	}

	void main() {
	  MAP m1;
	  MAP::iterator it;

      // Inserta en el conjunto los siguientes pares
      m1.insert(MAP::value_type(0,"Vicente"));
      m1.insert(pair<int,string>(1,"Marta"));   // Otra manera
      m1.insert(MAP::value_type(2,"Jose"));
      m1.insert(MAP::value_type(3,"Cecilia"));
      m1.insert(MAP::value_type(4,"Antonio"));
      m1.insert(MAP::value_type(5,"Carla"));
	  muestra(m1);

      // lo ignora por estar duplicado
      m1.insert(MAP::value_type(2,"Carlos"));
      muestra(m1);

      // Modifica el valor asociado a 2 y pasa a ser "Carlos"
      m1[2]="Carlos";
      muestra(m1);

      // Encuentra el valor 3 en el conjunto y lo muestra junto con 
      // su valor asociado
      it= m1.find(3);
      if (it!=m1.end()) cout<<(*it).first<<" " <<(*it).second<<endl;
      else cout<<"No encontrado\n";
	}
