//Cdigo de las pginas 429-430

#include <vector>
#include <iostream>
#include <algorithm>
using namespace std ;

template <class T> void muestra(const vector <T> &l) {
    // implementacin en la pgina 376
}

void main() { 
    int c1[] = {10,2,30,43,15,15,30,80,19,100};
    int c2[] = {10,2,30,43,5,5,3,80,19,100};
    int t1,t2;

    t1=sizeof(c1)/sizeof(int);
    t2=sizeof(c2)/sizeof(int);
    vector <int> v1(c1,c1+t1),v2(c2,c2+t2);

    cout << "Valores de v1";
    muestra(v1);
  	
    cout << "Valores de v2";
    muestra(v2);

    // pos, objeto formado por dos iteradores	
    pair <vector<int>::iterator,vector<int>::iterator> pos;

    // devuelve la 1 posicin de los dos elementos diferentes
    pos=mismatch(v1.begin(),v1.end(),v2.begin());
    if (pos.first!=v1.end() && pos.second!=v2.end()) {
      cout << "El primer elemento diferente en v1 es " << 
	        *pos.first << " y est en la posicin " << 
           pos.first-v1.begin() << endl;
      cout << "El primer elemento diferente en v2 es " << 
           *pos.second << " y est en la posicin " << 
           pos.second-v2.begin() << endl;
    }

    // comprueba si son iguales v1 y v2
    if (equal(v1.begin(),v1.end(),v2.begin()))
      cout<<"Son iguales v1 y v2\n";
    else cout<<"No son iguales v1 y v2\n";

    // comprueba si son iguales los primeros 
	 // tres elementos de v1 y v2
    if (equal(v1.begin(),v1.begin()+2,v2.begin()))
      cout << "Son iguales los tres primeros elementos "
				"de v1 y v2\n";
    else 
      cout << "No son iguales los tres primeros elementos "
             "de v1 y v2\n";

    cout << "El elemento de la secuencia v1 en el que se
            " encuentra la subsecuencia 80 19 es: " <<
    *search(v1.begin(),v1.end(),v2.begin()+7,v2.begin()+8)<<endl;
}

