//Cdigo de las pginas 439-440

#include <vector>
#include <iostream>
#include <algorithm>
using namespace std ;

template <class T> void muestra(const vector <T> &l) {
    // implementacin en la pgina 376
}

void main() {				   
    int c1[] = {101,20,41,15,6,18,90,120,12,115};
    int t1;

    t1=sizeof(c1)/sizeof(int);

    vector <int> v1(c1,c1+t1);
	
    cout << "Valores de v1";
    muestra(v1);
  	
    // Construccin del rbol binario
    make_heap(v1.begin(),v1.end());
    cout << "Valores de v1 despus de make_heap";
    muestra(v1);
	
    // Conversin a secuencia ordenada
    sort_heap(v1.begin(),v1.end());
    cout << "Valores de v1 despus de sort_heap";
    muestra(v1);
	
    // Conversin a montculo
    make_heap(v1.begin(),v1.end());
    cout << "Conversion de v1 a montculo";
    muestra(v1);

    // Aade 70 al final del vector
    v1.push_back(70);
    // Inserta 70 en el rbol binario
    push_heap(v1.begin(), v1.end());
    cout << "Valores de v1 despus de insertar 70 "
	         "al rbol binario";
    muestra(v1);
    // Intercambia el primer y ltimo elementos y 
	 // reorganiza los elementos menos el ltimo
    pop_heap(v1.begin(),v1.end());
    cout << "Valores del vector v1 despus de pop_heap";
    // Muestra los elementos del vector v1
    muestra(v1);
    // Elimina el ltimo elemento del vector
    v1.pop_back();
    cout << "Valores del montculo despus de pop_heap";
    muestra(v1);
}
