//Cdigo de las pginas 476-477

class Inmediato:public Operando {
public:
	Inmediato(Interprete *i) : Operando(i) {}
	TValor Leer();
	void Escribir(TValor v) throw(OperacionInvalida);
};

TValor Inmediato::Leer() {
	return formato.Valor;
}

void Inmediato::Escribir(TValor v) throw(OperacionInvalida) {
	throw OperacionInvalida(
			"No se puede escribir en operando inmediato");
};

class OpMemoria:public Operando {
public:
	OpMemoria(Interprete *i) : Operando(i) {}
	TValor Leer();
	void Escribir(TValor v) throw(OperacionInvalida);
};

TValor OpMemoria::Leer() {
	return pInterprete->ObtenerMemoria()->Leer(formato.Valor);
}

void OpMemoria::Escribir(TValor v) throw(OperacionInvalida){
	pInterprete->ObtenerMemoria()->Escribir(formato.Valor,v);
};

class OpRegistro:public Operando {
public:
	OpRegistro(Interprete *i) : Operando(i) {}
	TValor Leer();
	void Escribir(TValor v) throw(OperacionInvalida);
	virtual void Out(ostream&);
};

TValor OpRegistro::Leer() {
	return pInterprete->ObtenerRegistros()->Leer(formato.Valor);
}

void OpRegistro::Escribir(TValor v) throw(OperacionInvalida) {
	pInterprete->ObtenerRegistros()->Escribir(formato.Valor,v);
};
