	// ------------------------------------------------------------
	//
	// Fichero	           : CLista.h
	// Tipo Componente   : Especificacin
	// Sistema	           : Estndar ISO C++ 
	// Descripcin       : Clase Lista Circular
	// Proyecto          : Libro "C++ Estndar"
	// Autor             : EHO/JHO/MCJL
	// Versin           : 1.0
	//
	//-------------------------------------------------------------

	#ifndef _CLISTA_H_
	#define _CLISTA_H_

	#include	<cstddef>	// NULL

	class		clista {
	private:
		static info	Error;
		static info	C_Error;
		// Copia del error para retornar por referencia
		static void	Poner_Error(info & );

		class	nodo {	 // anidamiento de clases
		public:
			info	Dato;
			nodo	*Prev, *Prox;
			nodo(info i, nodo *p= NULL, nodo *q= NULL) {
				Dato= i; Prev= p; Prox= q;
			}
	
			~nodo()	{
			}
		};
		nodo	*POS;	 // Posicin en la lista

		int	Tam;		 // Tamao. As se simplifican las operaciones

	public:
		// Constructor por defecto
		clista();

		// Destructor
		~clista();

		// Mtodos constantes
	   	bool	Vacia() const;
	   	bool	Llena() const;
	   	info &Info() const;

		// Mtodos no constantes
	   	void	Insertar(info &);			// Insertar un elemento
	   	void	Suprimir();				// Suprimir un elemento
	   	const clista &operator ++();		// Moverse al prximo
 											// elemento. Preincremento
	   	const clista &operator --();		// Moverse al elemento 	
											// previo. Preincremento
	};
	#endif
