//Cdigo de las pginas 379-380

#include <iostream>
#include <memory>
#include <vector>
using namespace std;

class clase1 {
private: int a,b;
public: clase1(int a1,int b1){a=a1;b=b1;}
  int obtener_a(){return a;}
  int obtener_b(){return b;}
};

void main() {
  // a1 es un allocator de objetos de tipo clase1
  allocator<clase1> a1;
  const int N = 5;
  int i;

  cout << "Reserva de memoria, utilizando allocate" << endl;
  clase1 *p2=a1.allocate(N,0);
  cout << "Construccin de los objetos" << endl;
  clase1 *q2=p2;
  for(i = 0; i < N; ++i) {
    a1.construct(q2,clase1(i,i*2)); 
    ++q2;
  }

  cout << "Contenido utilizando address: \n";
  q2=p2;
  for (i=0;i<N;i++) {
    cout << "a= " << (a1.address(*q2))->obtener_a()
        << " b= " << (a1.address(*q2))->obtener_b() << endl;
    q2++;
  }

  cout << "Mostrando los datos utilizando []\n";
  q2 = p2;
  for ( i = 0; i < N; ++i ) {
    cout << "a= " << p2[i].obtener_a()
         << " b= " << p2[i].obtener_b() << endl;
    ++q2;
  }
  cout << endl;

  // Libera la memoria reservada
  a1.deallocate(p2,N);
}
