	//Cdigo de las pginas 388-389

	#include <list>
	#include <iostream>
	using namespace std ;

	template <class T> void muestra(const list <T> &l) {
      list<int>::iterator i;

      // Recorre y muestra la lista
      for (i = l.begin(); i != l.end(); ++i) cout << *i << " ";
      cout << endl;
	}

	void main() {
      int c1[] = {5,6,7};
      int c2[] = {8,9,10};

      // declara l1 y l2 como dos instancias de la clase list
      list<int> l1, l2;      // que almacenarn valores enteros

      // i ser un iterador que permitira recorrer las listas
      list<int>::iterator i; 

      // Inserta 2 al principio de la lista. l1 [2]
      l1.insert (l1.begin(), 2); 
      // Inserta 3 al final de la lista. l1 [2,3]
      l1.insert (l1.end(), 3); 
      // Inserta 1 al principio de la lista. l1 [1,2,3]  
      l1.insert (l1.begin(), 1);	
      muestra(l1);

      // Inserta 3 cuatros al final de la lista. l1 [1,2,3,4,4,4]
      l1.insert (l1.end(), 3, 4);
      muestra(l1);

      // Inserta los dos primeros elementos de c1 
	  // al final de la lista. l1 [1,2,3,4,4,4,5,6]
      l1.insert (l1.end(), c1, c1 + 2);
      muestra(l1);

      // Inserta en l2 los elementos de c2
      l2.insert (l2.begin(), c2, c2+3);
      // Inserta al final de l1 los elementos de l2. 
      // l1[1,2,3,4,4,4,5,6,8,9,10]
      l1.insert (l1.end(), l2.begin(), l2.end());
      muestra(l1);
	}
