//Cdigo de las pginas 425-427

#include <vector>
#include <iostream>
#include <algorithm>
#include <functional>
using namespace std ;

template <class T> void muestra(const vector <T> &l) {
    // implementacin en la pgina 376
}

void main() {				   
    int c1[] = {10,2,30,43,15,15,30,80,19,100};
    int c2[] = {30,80,19};
    int n=0,t1,t2;
    vector <int>::iterator pos;
    t1=sizeof(c1)/sizeof(int);
    t2=sizeof(c2)/sizeof(int);
    vector <int> v1(c1,c1+t1),v2(c2,c2+t2);

    cout << "Valores de v1";
    muestra(v1);

    // busca el nmero de veces que aparece 30,
	 // buscando elemento a elemento
    pos=v1.begin();
    while (pos!=v1.end()) { 
      pos=find(pos,v1.end(),30);
      if (pos!=v1.end()) {n++; pos++;}
    }
    if (n!=0) cout << "Se ha encontrado " << n << " veces 30\n";
    else cout << "No se ha encontrado ningn 30\n";

    // busca el nmero de elementos mayores a 10,
	 // buscando elemento a elemento
    pos=v1.begin();n=0;
    while (pos!=v1.end()) {
      pos=find_if(pos,v1.end(),bind2nd(greater<int>(), 10));
      if (pos!=v1.end()) {n++; pos++;}
    }
    if (n!=0) cout << "Se han encontrado " << n << 
                      " valores mayores a 10\n";
    else cout << "No se ha encontrado ningn valor mayor a 10\n";
   
    // busca el primer elemento de los primeros eltos. adyacentes
    pos=adjacent_find(v1.begin(),v1.end());
    if (pos!=v1.end()) cout << "Los elementos idnticos"
			" adyacentes son " << *pos << endl;
    else cout << "No hay elementos idnticos adyacentes\n";

    // busca el 1er elemento de los primeros elementos adyacentes
    cout << "Valores de v2";
    muestra(v2);
    pos=find_end(v1.begin(),v1.end(),v2.begin(),v2.end());
    if (pos!=v1.end()) {
      cout << "Los elementos desde el iterador devuelto por "
              "find_end hasta el final son\n";
      do {
        cout<<*pos<<" ";
        pos++;
      } while (pos!=v1.end());
    }
    else cout << "No ha encontrado la subsecuencia\n";
}
