//Cdigo de las pginas 436-438

#include <vector>
#include <iostream>
#include <algorithm>
using namespace std ;

template <class T> void muestra(const vector <T> &l) {

    // implementacin en la pgina 376
}

void main() {				   
    int c1[] = {1,2,4,5,6,8,9,10,12,15};
    int c2[] = {1,3,4,5,7};
    int t1,t2;

    t1=sizeof(c1)/sizeof(int);
    t2=sizeof(c2)/sizeof(int);
 
    vector <int> v1(c1,c1+t1),v2(c2,c2+t2),v3(t1);
    vector <int>::iterator final;
    ostream_iterator<int> salida(cout," ");
	
    cout << "Valores de v1";
    muestra(v1);
    cout << "Valores de v2";
    muestra(v2);

    // Comprueba si v2 est incluido en v1
    if (includes(v1.begin(),v1.end(),v2.begin(),v2.end()))
     cout << "v2 est incluido en v1\n";
    else cout << "v2 no est incluido en v1\n";
			  
    // v3 contendr la unin de los elementos de v1...v1+5 y v2
    final= set_union(v1.begin(),v1.begin()+6,
                     v2.begin(),v2.end(), v3.begin());
    cout << "Valores de v3. Unin de v1..v1+5 y v2\n";
    copy(v3.begin(),final,salida);

    // v3 contendr la interseccin de 
    // los elementos de v1...v1+5 y v2
    final= set_intersection(v1.begin(),v1.begin()+6,
                            v2.begin(), v2.end(),v3.begin());
    cout << "\nValores de v3. Interseccin de v1..v1+5 y v2\n";
    copy(v3.begin(),final,salida);
 	
    // v3 contendr la diferencia de v1 y v2
    final= set_difference(v1.begin(),v1.end(),
                          v2.begin(),v2.end(), v3.begin());
    cout << "\nValores de v3. Diferencia de v1 y v2\n";
    copy(v3.begin(),final,salida);

    // v3 contendr la diferencia simtrica de v1 y v2
    final= set_symmetric_difference(v1.begin(),v1.end(),
                                    v2.begin(), v2.end(),
                                    v3.begin());
    cout << "\nValores de v3. Diferencia simtrica de v1 y v2\n";
    copy(v3.begin(),final,salida);
}
